#ifndef __POLYGON_H__
#define __POLYGON_H__
#include "inertia.h"

extern Vertex *VertPtrA;
extern Vertex *VertPtrB;
extern Vertex *VertPtrC;

extern Vertex2d *TVA;
extern Vertex2d *TVB;
extern Vertex2d *TVC;

extern int      TotalHeight;
extern int      TopHeight;
extern int      BottomHeight;

extern int      CeilY1;
extern int      CeilY2;
extern int      CeilY3;

extern int      FXDLongX;
extern int      FXDLongDX;
extern int      FXDShortX;
extern int      FXDShortDX;

extern int      FXDSide1C;
extern int      FXDSide1DC;
extern int      FXDSide2C;
extern int      FXDSide2DC;

extern int      FXDSide1U;
extern int      FXDSide1DU;
extern int      FXDSide2U;
extern int      FXDSide2DU;

extern int      FXDSide1V;
extern int      FXDSide1DV;
extern int      FXDSide2V;
extern int      FXDSide2DV;

extern int      FXDSide1S;
extern int      FXDSide1DS;
extern int      FXDSide2S;
extern int      FXDSide2DS;

extern int      FXDSide1T;
extern int      FXDSide1DT;
extern int      FXDSide2T;
extern int      FXDSide2DT;

extern int      FXDSide1Z;
extern int      FXDSide1DZ;
extern int      FXDSide2Z;
extern int      FXDSide2DZ;

extern float    FLTInten1;
extern float    FLTInten2;
extern float    FLTInten3;

extern float    FLTTextureX1;
extern float    FLTTextureX2;
extern float    FLTTextureX3;

extern float    FLTTextureY1;
extern float    FLTTextureY2;
extern float    FLTTextureY3;

extern float    FLTEnvX1;
extern float    FLTEnvX2;
extern float    FLTEnvX3;

extern float    FLTEnvY1;
extern float    FLTEnvY2;
extern float    FLTEnvY3;

extern float    FLTLongDX;
extern float    FLTShortDX;

extern float    OneOverTotalDY;
extern float    OneOverTopDY;
extern float    OneOverBotDY;

extern float    PolyDX;

extern int      HorizontalDC;
extern int      HorizontalDU;
extern int      HorizontalDV;
extern int      HorizontalDS;
extern int      HorizontalDT;

extern int      YAddress;
extern int      Color;

extern int      UStart;
extern int      VStart;
extern int      SStart;
extern int      TStart;
extern int      CStart;
extern int      TextureOfsTable;
extern int      IBufferTable;
extern int      Count;
extern int      HDU8;
extern int      HDV8;
extern int      HDS8;
extern int      HDT8;

extern float    _tmp_flt;
extern float    _tmp_half;
extern float    _tmp_fixone;
extern float    _tmp_flt_63;
extern float    _tmp_flt_255;
extern float    FUDGE_FACTOR;

extern int      VirtualAddress;
extern int      LineSize;

void UnshadedPolygon(Triangle *Poly, char *VPage, int x, int y);
void AmbientPolygon(Triangle *Poly, char *VPage, int x, int y);
void LambertPolygon(Triangle *Poly, char *VPage, int x, int y);
void GouraudPolygon(Triangle *Poly, char *VPage, int x, int y);
void PhongPolygon(Triangle *Poly, char *VPage, int x, int y);

void UnshadedTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void AmbientTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void LambertTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void GouraudTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void PhongTexturePolygon(Triangle *Poly, char *VPage, int x, int y);

void UnshadedPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void AmbientPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void LambertPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void GouraudPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void PhongPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);

void UnshadedReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void AmbientReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void LambertReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void GouraudReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void PhongReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);

void TransUnshadedPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransAmbientPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransLambertPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransGouraudPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransPhongPolygon(Triangle *Poly, char *VPage, int x, int y);

void TransUnshadedTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransAmbientTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransLambertTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransGouraudTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransPhongTexturePolygon(Triangle *Poly, char *VPage, int x, int y);

void TransUnshadedPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransAmbientPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransLambertPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransGouraudPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);
void TransPhongPerspTexturePolygon(Triangle *Poly, char *VPage, int x, int y);


void TransUnshadedReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransAmbientReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransLambertReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransGouraudReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);
void TransPhongReflectionPolygon(Triangle *Poly, char *VPage, int x, int y);

#endif
